import java.util.Comparator;

import sort.Lexicographic;
import sort.QuickSort;
import sort.Reverse;
import sort.SortableDataWithComparator;
import sort.SwapableArray;
import sort.TrivialComparator;

public class TestLexicographic {
	public static void main(String[] args) {
		People[] peoples = { new People("Dupont", "Jean"),
				new People("Durand", "Jean"), new People("Martin", "Malin"),
				new People("Dupont", "Marcel"), new People("Martin", "Roger"),
				new People("Zebluz", "Agathe") };

		new QuickSort().doSort(new SortableDataWithComparator<People>(
				new SwapableArray<People>(peoples), new Reverse<People>(
						new Lexicographic<People, String, String>() {
							Comparator<String> compString = new TrivialComparator<String>();

							protected final Comparator<String> getComparator1() {
								return compString;
							}

							protected final Comparator<String> getComparator2() {
								return compString;
							}

							public final String projection1(People p) {
								return p.name();
							}

							public final String projection2(People p) {
								return p.firstname();
							}

						})));

		for (People p : peoples) {
			System.out.println(p);
		}
	}
}
